﻿using Microsoft.Web.Services3;
using System.Security.Cryptography.Xml;
using System.Xml;

namespace ConsoleApp1
{
    // Extension of the SignedXml class in order to accept wsu:Id atrributes as identifiers.
    internal class SignedXmlWithId : SignedXml
    {
        public SignedXmlWithId(SoapEnvelope envelope) : base(envelope)
        {
        }

        public override XmlElement GetIdElement(XmlDocument document, string idValue)
        {
            XmlElement idElem = base.GetIdElement(document, idValue);

            if (idElem == null)
            {
                XmlNamespaceManager nsManager = new XmlNamespaceManager(document.NameTable);
                nsManager.AddNamespace("wsu", "http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-utility-1.0.xsd");

                idElem = document.SelectSingleNode("//*[@wsu:Id=\"" + idValue + "\"]", nsManager) as XmlElement;
            }

            return idElem;
        }
    }
}